
// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
// ios  id : net.inu4j.visiontrip
// android id : inu4j.ionic.visiontrip
var appVersion = "1.6.5";
var self_module = angular.module('starter', ['ionic', 'starter.controllers', 'ngCordova', 'ngCookies', 'pascalprecht.translate', 'ngIOS9UIWebViewPatch', 'firebase'])

  .config(function ($translateProvider) {

    // 초기값이 없을경우  임시.. 스페니쉬를 디폴트로.. (선택 부분을 만들어야 함)
    if (!window.localStorage.getItem("target_language")) {
      window.localStorage.setItem("target_language", "NONE");
    }
    var target_lang = window.localStorage.getItem("target_language");
    console.log("초기 Config / target lang = " + target_lang),

      $translateProvider.useStaticFilesLoader({
        prefix: 'locale/',
        suffix: '.json'
      });

    // for (lang in trans){
    //    $translateProvider.translations(lang, trans[lang]);    
    //  }

    // $translateProvider.preferredLanguage("ko_KR");
    // remember language
    // console.log("Set LocalStorage");

    $translateProvider.useLocalStorage();
    $translateProvider.useSanitizeValueStrategy('escaped');
  })

  // .run(function($ionicPlatform, $translate, $translateLocalStorage ) {
  .run(function ($ionicPlatform, $ionicPopup, $state, $translate) {
    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)

      // screen.lockOrientation('portrait');
      // screen.orientation.lock('portrait');
      console.log('Orientation is ' + screen.orientation);

      var notificationOpenedCallback = function (jsonData) {
        console.log('notificationOpenedCallback: '); //+ JSON.stringify(jsonData)
        refreshPush();
        // //푸쉬를 받았을 때 실행됨. 
        // var temp = JSON.parse(JSON.stringify(jsonData));

        // // Display the month, day, and year. getMonth() returns a 0-based number.
        // var dt = new Date();

        // var push_msg = {
        //   id : temp.notification.payload.notificationID,
        //   date : dt, 
        //   title : temp.notification.payload.title,
        //   body : temp.notification.payload.body,
        //   img_url : temp.notification.payload.additionalData.img_url
        // }
        // console.log (JSON.stringify(push_msg));
        // setLocalStorage(push_msg);
      };

      // var setLocalStorage = function(push_msg){
      //   var push_msg_list = [];
      //   var getmsg = JSON.parse( window.localStorage.getItem("push_msg_list") );
      //   if (getmsg==null){
      //     push_msg_list.unshift(push_msg);
      //   }else{
      //     push_msg_list = getmsg;
      //     push_msg_list.unshift(push_msg);
      //   }
      //   window.localStorage.setItem("push_msg_list", JSON.stringify(push_msg_list));
      // };
      var refreshPush = function () {
        var msgRef = firebase.database().ref('push/').orderByChild('/date').limitToLast(50);
        var push_msg_list = new Array();
        msgRef.once('value', function (snapshot) {
          // console.log(snapshot.val());
          snapshot.forEach(function (childSnapshot) {
            // console.log(childSnapshot.val());
            push_msg_list.unshift(childSnapshot.val());
          });

        }).then(function (snapshot) {
          if (snapshot) {
            console.log("Refresh Message Success ******* ");
            window.localStorage.setItem("push_msg_list", JSON.stringify(push_msg_list));
            checkReadMsg();
          }
        });
      };

      var checkReadMsg = function () {
        var readMsgId = JSON.parse(window.localStorage.getItem("readMsgId"));
        console.log("****HOME READED Msg");
        console.log(JSON.stringify(readMsgId));

        var push_msg_list = JSON.parse(window.localStorage.getItem("push_msg_list"));
        console.log("****Push Msg");
        // console.log(JSON.stringify(push_msg_list));

        var unreadMsgId = [];
        angular.forEach(push_msg_list, function (pushitem) {
          if (!isArray(readMsgId, pushitem.id)) {
            unreadMsgId.push(pushitem.id);
          }
        });
        console.log("UnRead MSG ID");
        console.log(unreadMsgId);
        window.localStorage.setItem("unreadMsgId", JSON.stringify(unreadMsgId));

        if (unreadMsgId.length > 0) {
          // A confirm dialog

        $translate(['noti_alert_title', 'noti_alert_message'])
          .then(function (translations) {
            var confirmPopup = $ionicPopup.confirm({
              title: translations.noti_alert_title,
              template: translations.noti_alert_message
            });

            confirmPopup.then(function (res) {
              if (res) {
                console.log('Go Notilist');
                $state.go('app.notilist');
              } else {
                console.log('Cancel Notilist');
              }
            });

          }); //translate

        }
      };

      refreshPush();

      window.plugins.OneSignal
        .startInit("ce8659d3-db21-47ad-b067-d8890b0d32a7")
        .handleNotificationOpened(notificationOpenedCallback)
        .handleNotificationReceived(function (jsonData) {
          refreshPush();
          // alert("Notification Received"  + JSON.stringify(jsonData) );
          console.log('receive a notification In App');
        })
        .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
        .endInit();


      if (window.cordova && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        // StatusBar.styleDefault();
        StatusBar.overlaysWebView(true);
        StatusBar.styleDefaultContent();
        StatusBar.show();
      }



      //app version 구하기
      // if (window.cordova) {
      //   cordova.getAppVersion(function(version) {
      //     appVersion = version;
      //     console.log("App Version : " + appVersion);
      //   });
      // }
      // IOS 상단바 / Device text 를 white 로
      // styles: Default : 0, LightContent: 1, BlackTranslucent: 2, BlackOpaque: 3


    })
  })


  .run(function ($cordovaSplashscreen) {
    setTimeout(function () {
      $cordovaSplashscreen.hide();
    }, 5000)
  })

  // device 의 default 언어로 초기 언어를 셋팅하고, 없으면 en 으로 셋팅.  사용자가 설정했을 경우는 설정언어를 가져온다. 
  .run(['$ionicPlatform', '$translate', '$translateLocalStorage',
    function ($ionicPlatform, $translate, $translateLocalStorage) {
      $ionicPlatform.ready(function () {
        if ($translateLocalStorage.get() == "undefined" || $translateLocalStorage.get() == null) {   // 최초의 실행일 경우.
          if (typeof navigator.globalization !== "undefined") {
            navigator.globalization.getPreferredLanguage(function (language) {
              // alert(language.value);
              console.log("Device Lang = " + language.value);
              $translate.use(language.value).then(function (data) {        // 제공하는 경우는 자동으로 적용 
                       
              }, function (error) {                                         // 에러가 나는 경우에는 en 으로 적용됨. 
                // alert("Not support your language");
                $translate.use('en-US');
              });
            }, null);
          } else {
            console.log("get Lang Fail = en-US");
            $translate.use('en-US');

          }
        }
      });
    }])

  .config(['$ionicConfigProvider', function ($ionicConfigProvider) {

    $ionicConfigProvider.tabs.position('bottom'); // other values: top

  }])

  .config(function ($stateProvider, $urlRouterProvider) {

    $stateProvider

      .state('app', {
        url: "/app",
        abstract: true,
        templateUrl: "templates/menu.html",
        controller: 'AppCtrl'
      })

      .state('app.home', {
        url: "/home",
        views: {
          'menuContent': {
            templateUrl: "templates/home.html"
          }
        }
      })

      .state('app.gospel', {
        url: "/gospel",
        views: {
          'menuContent': {
            templateUrl: "templates/gospel.html",
            controller: 'GospelCtrl'
          }
        }
      })

      .state('app.notilist', {
        url: "/notilist",
        views: {
          'menuContent': {
            templateUrl: "templates/noti_list.html",
            controller: 'NotiListCtrl'
          }
        }
      })
      .state('app.noticontent', {
        url: "/notilist/:notiId",
        views: {
          'menuContent': {
            templateUrl: "templates/noti_content.html",
            controller: 'NotiContentCtrl'
          }
        }
      })

      .state('app.playlists', {
        url: "/playlists",
        views: {
          'menuContent': {
            templateUrl: "templates/praise_list.html",
            controller: 'PlaylistsCtrl'
          }
        }
      })


      .state('app.single', {
        url: "/playlists/:playlistId",
        views: {
          'menuContent': {
            templateUrl: "templates/praise.html",
            controller: 'PlaylistCtrl'
          }
        }
      })

      .state('app.language', {
        url: "/language",
        views: {
          'menuContent': {
            templateUrl: "templates/language.html"
          }
        }
      })

      .state('app.contry', {
        url: "/contry",
        views: {
          'menuContent': {
            templateUrl: "templates/contry.html"
          }
        }
      })

      .state('app.manual', {
        url: "/manual",
        views: {
          'menuContent': {
            templateUrl: "templates/manual.html"
          }
        }
      })

      .state('app.setting', {
        url: "/setting",
        views: {
          'menuContent': {
            templateUrl: "templates/setting.html"
          }
        }
      })

      // .state('app.donation', {
      //   url: "/donation",
      //   views: {
      //     'menuContent': {
      //       templateUrl: "templates/donation.html"
      //     }
      //   }
      // })
      // .state('app.share', {
      //   url: "/share",
      //   views: {
      //     'menuContent': {
      //       templateUrl: "templates/share.html"
      //     }
      //   }
      // })

      .state('app.information', {
        url: "/information",
        views: {
          'menuContent': {
            templateUrl: "templates/information.html"
          }
        }
      })

      .state('app.bookmark', {
        url: "/bookmark",
        views: {
          'menuContent': {
            templateUrl: "templates/bookmark.html"
          }
        }
      });

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/app/home');
  });
